#!/usr/bin/perl -w

$confGmetric = "/usr/bin/gmetric --tmax=4000 --dmax=4000";
$confSmartctl= "/usr/sbin/smartctl";
$confGanglia = "/etc/gmond.conf";

die "Ganglia is not installed"  if ! -r $confGanglia;

my $gmetricDest = "";

if (1)
  {
    my $ip;
    my $port;
    
    open(IN,"$confGanglia") || die "Cannot read $confGanglia";
    while (<IN>)
      {
        next if /^#/;
        $ip   = $1 if /mcast_channel +(.*)/;
        $port = $1 if /mcast_port +(.*)/;
      }
    close IN;
    
    $gmetricDest .= " -c$ip " if defined $ip;
    $gmetricDest .= " -p$port " if defined $port;
  }

exit 0 unless -r "/sys/block";

my %suppress;
#$suppress{1} = 1;
#$suppress{3} = 1;
#$suppress{7} = 1;
#$suppress{9} = 1;

foreach my $dev (`/bin/ls -1 /sys/block`)
  {
    chop $dev;
    next if ! -r "/sys/block/$dev/device";

    my $smartData = `$confSmartctl -a /dev/$dev 2>&1`;

    #print $smartData;
    
    foreach my $entry (split(/\n/,$smartData))
      {
        #print "-> $entry\n";
        
        $entry =~ s/^\s*//;
        my @entry = split(/\s+/,$entry);
        
        next if (@entry != 10);
        
        my $id   = $entry[0];
        my $name = $entry[1];
        my $val  = $entry[9];
        
        next unless $id  =~ /^\d+$/;
        next unless $val =~ /^\d+$/;

        next if $suppress{$id};
        
        $id = sprintf("%3d",$id);
        
        #print scalar @entry,$entry[0],$entry[1],"  $entry\n";
        
        my $cmd = "$confGmetric $gmetricDest -tint32 -n\"smart $dev $id $name\" -v$val";
        #print "$cmd\n";
        system $cmd;
     }
  }

exit 0;
#end file
